
#ifndef ntl_pair__H
#define ntl_pair__H

#include "tools.h"

#define ntl_pair_decl(S,T,pair_S_T)  \
class pair_S_T {  \
public:  \
   S a;  \
   T b;  \
  \
   pair_S_T() { }  \
   pair_S_T(const pair_S_T& x) : a(x.a), b(x.b) { } \
   pair_S_T& operator=(const pair_S_T& x) { a = x.a; b = x.b; return *this; } \
   pair_S_T(const S& x, const T& y) : a(x), b(y) { }  \
   ~pair_S_T() { }  \
};  \
  \
inline pair_S_T cons(const S& x, const T& y) { return pair_S_T(x, y); } \




#define ntl_pair_io_decl(S,T,pair_S_T) \
istream& operator>>(istream&, pair_S_T&);  \
  \
ostream& operator<<(ostream&, const pair_S_T&);  \



#define ntl_pair_eq_decl(S,T,pair_S_T)  \
inline long operator==(const pair_S_T& x, const pair_S_T& y)  \
   { return x.a == y.a && x.b == y.b; }  \
inline long operator!=(const pair_S_T& x, const pair_S_T& y) \
   { return !(x == y); }  \



// For compatability...
#define ntl_pair_impl(S,T,pair_S_T)


#define ntl_pair_io_impl(S,T,pair_S_T)  \
istream& operator>>(istream& s, pair_S_T& x)  \
{  \
   long c;  \
  \
   if (!s) Error("bad pair input");  \
  \
   c = s.peek();  \
   while (c == ' ' || c == '\n' || c == '\t') {  \
      s.get();  \
      c = s.peek();  \
   }  \
  \
   if (c != '[')  \
      Error("bad pair input");  \
  \
   s.get();  \
  \
   if (!(s >> x.a))   \
      Error("bad pair input");  \
   if (!(s >> x.b))  \
      Error("bad pair input");  \
  \
   c = s.peek();  \
   while (c == ' ' || c == '\n' || c == '\t') {  \
      s.get();  \
      c = s.peek();  \
   }  \
  \
   if (c != ']')  \
      Error("bad pair input");  \
  \
   s.get();  \
  \
   return s;  \
}  \
  \
ostream& operator<<(ostream& s, const pair_S_T& x)  \
{  \
   return s << "[" << x.a << " " << x.b << "]";  \
}  \



// For compatability...
#define ntl_pair_eq_impl(S,T,pair_S_T)




#endif
